<?php
/**
 * @category	Modules
 * @package		JomSocial
 * @subpackage	mod_groupcategories
 * @copyright   Copyright (C) 2013 - 2014 Open Source Matters, Inc. All rights reserved.
 * @author      Suman Singh <pankaj.tahiliani@dotsquares.com>
 * @license	GNU General Public License version 2 or later; see LICENSE.php
 *
	This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

defined('_JEXEC') or die('Restricted access');
require_once( JPATH_ROOT . DS . 'components' . DS . 'com_community' . DS . 'libraries' . DS . 'core.php');
require_once( JPATH_ROOT . DS . 'components' . DS . 'com_community' . DS . 'helpers' . DS . 'string.php' );

class modGroupCategoryhelper
{
	 /* 
		* Function
		* @author   Suman Singh
		* @purpose  To fetch all group categories
		* @uses   	used into mod_groupcategories.php
		* @return  	array
	 */
	function getGroupCategories(&$params) {
		//cache groups categories
		$model	    = CFactory::getModel( 'groups' );
		$categories = $model->getCategoriesCount();
		
		//sortby
		modGroupCategoryhelper::aasort($categories,$params->get('sortby', 0),$params->get('sortorder', 0));
		
		if (is_numeric($params->get('count', 0))) {
        $limit = $params->get('count', 0);
		$categories = modGroupCategoryhelper::getLimitedCategories($categories,$limit);
		}
		
		//CFactory::load('helpers','category');
		//$categories = CCategoryHelper::getParentCount($categories, $category);
		
		return $categories;
	}
	
	/* 
		* Function
		* @author   Suman Singh
		* @purpose  To limit the group categories array
		* @return  	array
	*/
	function getLimitedCategories($categories=array(),$limit=0) {
		$limit = (int)$limit;
		$resutls = array();
		if($limit == 0 || empty($categories)) {
			return $categories;
		} else {
			$counter = 1;
			foreach($categories as $category) {
				if($counter <= $limit) {
					$resutls[] = $category;
				}
				$counter++;
			}
		}
		return $resutls;
	}
	
	/* 
		* Function
		* @author   Suman Singh
		* @purpose  To sort the group categories array based on supplyed key and order
		* @return  	array
	*/
	function aasort(&$array,$key,$order='ASC') {
		$sorter=array();
		$ret=array();
		reset($array);
		foreach ($array as $ii => $va) {
			$sorter[$ii]=$va->$key;
		}
		
		if($order == 'ASC') {
			// low to high = ascending
			asort($sorter);
		}
		
		if($order == 'DESC') {
			// high to low = descending
			arsort($sorter);
		}
		
		foreach ($sorter as $ii => $va) {
			$ret[$ii]=$array[$ii];
		}
		$array=$ret;
	}
}